/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/

#include "stdafx.h"

#include <winsock.h>
#include <mmsystem.h>

#ifndef WIN16
#include <winver.h>
#endif             
             
#include "email.h"
#include "mainfrm.h"
#include "emaildoc.h"
#include "logodial.h"
#include "register.h"
#include "idhindex.h"
#include "pwdlg.h"

#ifdef LISTVIEW
#include "emlistvw.h"
#else
#include "emailvw.h"
#endif



#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CEmailApp

BEGIN_MESSAGE_MAP(CEmailApp, CWinApp)
	//{{AFX_MSG_MAP(CEmailApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_HELP_REGISTER, OnHelpRegister)
	ON_COMMAND(ID_WWW_HOMEPAGE, OnWWWHomepage)
	ON_COMMAND(ID_WWW_FAQ, OnWWWFAQ)
	ON_COMMAND(ID_WWW_DOWNLOAD, OnWWWDownload)
	ON_COMMAND(ID_HELP_APPLY_REG, OnHelpApplyReg)
	ON_COMMAND(ID_WWW_REGISTER, OnWWWRegister)
	ON_COMMAND(ID_HELP_REGISTRATION, OnHelpRegistration)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()


BOOL bWin4;
BOOL bRasOk;

/////////////////////////////////////////////////////////////////////////////
// The one and only CEmailApp object

CEmailApp theApp;




// Get pointer on common objects
//
// Be carefull if you use a window or doc object
// in another thread than the one where they have
// been created.
//
CEmailApp* AfxGetEmailApp()
{
 return &theApp;
}


CMainFrame* AfxGetMainFrame()
{
 return (CMainFrame*)theApp.GetMainWnd();
}


CEmailDoc* AfxGetEmailDoc()
{
 return (CEmailDoc*)(AfxGetMainFrame()->GetActiveDocument());
}


CPOPClient* AfxGetPOPClient()
{
 return AfxGetMainFrame()->GetPOPClient(); 
}


CNotifySettings* AfxGetConfig()
{
 return theApp.m_pConfig;
}



/////////////////////////////////////////////////////////////////////////////
// CEmailApp construction

CEmailApp::CEmailApp()
{
 DWORD dwVersion = ::GetVersion();
 
 bWin4 = (LOBYTE(LOWORD(dwVersion))>=4);
 uSettingsNb = 0;
 LogoDialog = NULL;
 m_pConfig = NULL;
}


CEmailApp::~CEmailApp()
{
 if (LogoDialog) delete LogoDialog;
 if (m_pConfig) delete m_pConfig;
 WSACleanup();
}


    
    
    
/////////////////////////////////////////////////////////////////////////////
// CEmailApp initialization

BOOL CEmailApp::InitInstance()
{

	bHide	= FALSE;
    bNoLogo = FALSE;

	if (m_lpCmdLine[0] != '\0')
	{
	 char far* cmd[20];
	 int num = 0;
	 int pos = 0;

	 while ((m_lpCmdLine[pos]!='\0')&&(m_lpCmdLine[pos]==' '))
	   pos++;
	 cmd[0] = m_lpCmdLine+pos;
	 
	 while ((m_lpCmdLine[pos]!='\0')&&(num<20))
	  {
	   while ((m_lpCmdLine[pos]!='\0')&&(m_lpCmdLine[pos]!=' '))
	 	pos++;
	   while ((m_lpCmdLine[pos]!='\0')&&(m_lpCmdLine[pos]==' '))
	    pos++;
	   num++;
	   if (m_lpCmdLine[pos]!='\0') m_lpCmdLine[pos-1]='\0';
	   cmd[num]=m_lpCmdLine+pos;
	   pos++;
	  }
	 
	for (int i=0;i<num;i++)
	  {
	   if ((strncmp(cmd[i],"/H",2)==0)||(strncmp(cmd[i],"/h",2)==0))
	    bHide = TRUE;
	   if ((strncmp(cmd[i],"/S",2)==0)||(strncmp(cmd[i],"/s",2)==0))
	    uSettingsNb = atoi(cmd[i]+2);
	   if ((strncmp(cmd[i],"/N",2)==0)||(strncmp(cmd[i],"/n",2)==0))
	    bNoLogo = TRUE;
	  }
	} 


	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef WIN32
	SetRegistryKey("Interactive");
	Enable3dControls();
#endif
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	AfxSocketInit();

#if defined(WIN95) || defined(WINNT35)
	if (InitRAS()==0)
		bRasOk = TRUE;
	else
#endif
		bRasOk = FALSE;

	// Create Config Object
	m_pConfig = new CNotifySettings(this,uSettingsNb);

	if (m_pConfig==NULL)
	 {
      // Impossible de creer l'objet de Configuration
		return FALSE;
     }

    m_nCmdShow = SW_HIDE;

#ifndef FREEWARE
#if defined(WIN95) || defined(WINNT35)
 if (!AfxGetConfig()->CheckRegistration())
  {
    int iRunsLeft = AfxGetConfig()->CheckRunsLeft();

	if (iRunsLeft>0)
	{
    CLogoDialog LogoDialog(iRunsLeft);
    LogoDialog.DoModal();  
    }
    else
	{
    AfxMessageBox(IDS_EVALUATION);
	CLogoDialog LogoDialog(iRunsLeft);
    LogoDialog.DoModal();  
	}
		
		
  }	
#endif
#endif

  if (AfxGetConfig()->m_bPOPPasswordAskStartup)
   CPasswordDlg::CheckPassword();
 
  // Get the starting window size before we create the window
  CString strWindowPos = AfxGetConfig()->m_csUIMainWindowPos;
  
 // Register the application's document templates.  Document templates
 //  serve as the connection between documents, frame windows and views.


   CSingleDocTemplate* pDocTemplate;

#ifndef FREEWARE
#ifdef LISTVIEW
   pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CEmailDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CEmailListView));
#else
   pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CEmailDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CEmailView));
#endif
#else
#ifdef LISTVIEW
   pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME_FW,
		RUNTIME_CLASS(CEmailDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CEmailListView));
#else
   pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME_FW,
		RUNTIME_CLASS(CEmailDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CEmailView));
#endif

#endif
   
   AddDocTemplate(pDocTemplate);

	// create a new (empty) document
	OnFileNew();

  int uPos = 0;
  CRect crRect;

  uPos = strWindowPos.Find(_T(","));
  if (uPos==-1)
   crRect.left = 100;
  else
   crRect.left = atoi(strWindowPos.Left(uPos)); 
  
  strWindowPos = strWindowPos.Mid(uPos + 1);
  uPos = strWindowPos.Find(_T(","));
  if (uPos==-1)
   crRect.top = 100;
  else
   crRect.top = atoi(strWindowPos.Left(uPos)); 
  strWindowPos = strWindowPos.Mid(uPos + 1);
  uPos = strWindowPos.Find(_T(","));
  if (uPos==-1)
   {
    crRect.right = 600;
    crRect.bottom = 400; 
   }
  else                  
   {
    crRect.right = atoi(strWindowPos.Left(uPos)); 
    crRect.bottom = atoi(strWindowPos.Mid(uPos + 1));
   }
   
  if (!AfxGetMainFrame()->IsIconic())
   AfxGetMainFrame()->MoveWindow(crRect);

  if (bHide||AfxGetConfig()->m_bUIStartHidden)
	    {
#ifdef WIN95
	  if (bWin4)
		m_nCmdShow = SW_HIDE;	
      else
	    m_nCmdShow = SW_MINIMIZE | SW_SHOW;
#else
	 	m_nCmdShow = SW_MINIMIZE | SW_SHOW;	
#endif
		}
  else
	   m_nCmdShow = SW_RESTORE;	
      
  AfxGetMainFrame()->ShowWindow(m_nCmdShow);
  return TRUE;
}


void CEmailApp::CloseLogo()
{
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
    //{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_version;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_version = CString(AfxGetAppName()); 
#ifdef WIN95
	m_version += " for Windows 95 v";
#elif defined(WIN32S)
	m_version += " for Win32s v";
#elif defined(WINNT35)
	m_version += " for Windows NT v";
#elif defined(WIN16)
	m_version += " for Windows 3.1 v";
#endif
	m_version += AfxGetEmailApp()->GetVersion();
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_VERSION, m_version);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CEmailApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CEmailApp commands





CString CEmailApp::GetVersion()
{
#ifndef WIN16
 VS_FIXEDFILEINFO* vsInfo;
 char cBuffer[256];
 UINT uSize;
 char *cFileName;
 cFileName = GetCommandLine();
 DWORD dwSize = GetFileVersionInfoSize(cFileName,(unsigned long*)cBuffer);
 
 if (dwSize!=0)
  {
   char* pVersion = new char[dwSize]; 
   GetFileVersionInfo(cFileName,0,dwSize,pVersion);
   VerQueryValue(pVersion,"\\",(void**)&vsInfo,&uSize);
   sprintf(cBuffer,"%d.%02d",HIWORD(vsInfo->dwProductVersionMS),
						   LOWORD(vsInfo->dwProductVersionMS));
   delete[] pVersion; 
   return cBuffer;
  }
 else
#endif
	 return "1.22";
}

void CEmailApp::OnHelpRegister() 
{
#ifndef FREEWARE
#if defined(WIN95) || defined(WINNT35)
 CRegister dlg;
 dlg.DoModal();
#else
 AfxMessageBox(IDS_REGISTER_WINDOWS);
#endif
#else
 AfxMessageBox(IDS_NOTIFYISFREEWARE);
#endif
}

int CEmailApp::ExitInstance() 
{
#if defined(WIN95) || defined(WINNT35)
	ExitRAS();
#endif
 return CWinApp::ExitInstance();
}


void CEmailApp::OnWWWHomepage() 
{
 CString strmessage;
 if (strmessage.LoadString(IDS_WWW_HOMEPAGE))
   ShowWebPage(strmessage);
 else
   AfxMessageBox("Internal Error");
}

void CEmailApp::OnWWWFAQ() 
{
 CString strmessage;
 if (strmessage.LoadString(IDS_WWW_FAQ))
	ShowWebPage(strmessage);
 else
   AfxMessageBox("Internal Error");
}

void CEmailApp::OnWWWDownload() 
{
 CString strmessage;
 if (strmessage.LoadString(IDS_WWW_DOWNLOAD))
	ShowWebPage(strmessage);
 else
   AfxMessageBox("Internal Error");
}

void CEmailApp::OnWWWRegister() 
{
 CString strmessage;
 if (strmessage.LoadString(IDS_WWW_REGISTER))
	ShowWebPage(strmessage);
 else
   AfxMessageBox("Internal Error");
}

void CEmailApp::OnHelpApplyReg() 
{
 WinHelp(IDH_HELP_APPLY_REG); 
}


void CEmailApp::OnHelpRegistration() 
{
 WinHelp(IDH_REGISTER); 
}


void CEmailApp::ShowWebPage(CString strPage)
{
  if (ShellExecute(NULL,"open",strPage,NULL,NULL,SW_SHOW)<=(HINSTANCE)32)
   {
    CString strmessage;
    if (strmessage.LoadString(IDS_WWW_POINT))
		AfxMessageBox(strmessage + " " + strPage);
	else
        AfxMessageBox("Internal Error");
   }
}
