/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/

#include "stdafx.h"
#include "email.h"
#include "Logon.h"
#include "idhindex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLogon dialog

static DWORD Mapping[] = 
 {
	IDC_EDIT_PASSWORD, IDH_RAPASSWORD,
	IDC_EDIT_USERNAME, IDH_RAUSERNAME
 };


CLogon::CLogon(CWnd* pParent,const CString& csUserName,const CString& csPassword)
	: CDialog(CLogon::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLogon)
	m_password = csPassword;
	m_username = csUserName;
	//}}AFX_DATA_INIT
}


void CLogon::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLogon)
	DDX_Text(pDX, IDC_EDIT_PASSWORD, m_password);
	DDX_Text(pDX, IDC_EDIT_USERNAME, m_username);
	//}}AFX_DATA_MAP
}



#ifdef WIN32
LONG CLogon::OnHelp(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)((HELPINFO*)lParam)->hItemHandle,AfxGetApp()->m_pszHelpFilePath,HELP_WM_HELP,(DWORD)&Mapping);
}


LONG CLogon::OnContextMenu(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)wParam,AfxGetApp()->m_pszHelpFilePath,HELP_CONTEXTMENU,(DWORD)&Mapping);
}
#endif            
            

BEGIN_MESSAGE_MAP(CLogon, CDialog)
	//{{AFX_MSG_MAP(CLogon)
	//}}AFX_MSG_MAP
#ifdef WIN32
	ON_MESSAGE(WM_HELP,OnHelp)
    ON_MESSAGE(WM_CONTEXTMENU,OnContextMenu)
#endif
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLogon message handlers
