/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/

 //
 // NOTE: this code is not used anymore in the Freeware version 
 // 

#include "stdafx.h"
#include "email.h"
#include "Register.h"
#include "idhindex.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRegister dialog


CRegister::CRegister(CWnd* pParent /*=NULL*/)
	: CDialog(CRegister::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRegister)
	m_email = AfxGetConfig()->m_csREGISTEREmail;
	m_reg = AfxGetConfig()->m_csREGISTERFile;
	m_name = AfxGetConfig()->m_csREGISTERName;
	//}}AFX_DATA_INIT
}


void CRegister::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegister)
	DDX_Text(pDX, IDC_EDIT_EMAIL, m_email);
	DDX_Text(pDX, IDC_EDIT_FILE, m_reg);
	DDX_Text(pDX, IDC_EDIT_NAME, m_name);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRegister, CDialog)
	//{{AFX_MSG_MAP(CRegister)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDHELP, OnHelp)
	ON_BN_CLICKED(ID_HELP_APPLY_REG, OnHelpApplyReg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegister message handlers

void CRegister::OnBrowse() 
{
 UpdateData(TRUE);
 OPENFILENAME ofn;
 memset(&ofn, 0, sizeof(ofn));

 ofn.lStructSize=sizeof(ofn);
 ofn.hwndOwner = GetSafeHwnd();
 ofn.lpstrFilter = "e-Mail Notify Files\0*.*";
 ofn.lpstrCustomFilter = NULL;
 ofn.nFilterIndex = 0;
 ofn.lpstrFile = new char[255];
 strncpy(ofn.lpstrFile,"",255);
 ofn.nMaxFile = 255;
 ofn.lpstrFileTitle = "Choose the registration file";
 ofn.lpstrInitialDir = NULL;
 ofn.Flags = OFN_HIDEREADONLY;
 #ifdef WIN95
 ofn.Flags |= OFN_EXPLORER;
 #endif

 if (GetOpenFileName(&ofn))
  {
   m_reg = ofn.lpstrFile;
   UpdateData(FALSE);
  }	
 delete[] ofn.lpstrFile;
}

void CRegister::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CRegister::OnHelp() 
{
  AfxGetApp()->WinHelp(IDH_REGISTER); 
}

void CRegister::OnOK() 
{
 UpdateData(TRUE);
 AfxGetConfig()->m_csREGISTEREmail = m_email;
 AfxGetConfig()->m_csREGISTERFile = m_reg;
 AfxGetConfig()->m_csREGISTERName = m_name;
 AfxGetConfig()->SaveProfileString();

 if (AfxGetConfig()->CheckRegistration())
   { 
	 AfxMessageBox(IDS_REGISTER_OK);
     CDialog::OnOK();
   }
 else
	 AfxMessageBox(IDS_REGISTER_FAILED);
   
}

void CRegister::OnHelpApplyReg() 
{
 AfxGetApp()->WinHelp(IDH_HELP_APPLY_REG);
}
