/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/



#ifndef _debug_h
#define _debug_h

#define _debug 0


#define _traceallocs 1
//#define _tracedeleter
// #define _mapallocs


// ifdef NDEBUG there should be no debugging
#ifndef NDEBUG


void OutputDebug(const char *Format,...);



#define OK        0
#define NOMEM     1
#define SYNTAX    2
#define NOSUCHCMD 3

#define PROCEED  0
#define FATAL    1


#define DEBUG(a) OutputDebug a


#if _debug > 0
#define DEBUG1(a) OutputDebug a
#else
#define DEBUG1(a)
#endif


#if _debug > 1
#define DEBUG2(a) OutputDebug a
#else
#define DEBUG2(a)
#endif

#if _debug > 2
#define DEBUG3(a) OutputDebug a
#else
#define DEBUG3(a)
#endif

#if _debug > 3
#define DEBUG4(a) OutputDebug a
#else
#define DEBUG4(a)
#endif

#if _debug > 4
#define DEBUG5(a) OutputDebug a
#else
#define DEBUG5(a)
#endif


#ifdef _traceallocs
#define TRACEALLOCS(a) OutputDebug a
extern unsigned AllocCount;
void ShowMapAllocPtrs();

#ifdef _mapallocs
#define MAPALLOCS ShowMapAllocPtrs()
#else
#define MAPALLOCS
#endif

#else
#define TRACEALLOCS(a)
#define MAPALLOCS
#endif


#ifdef _tracedeleter
#define TRACEDELETER(a) OutputDebug a
#else
#define TRACEDELETER(a)
#endif


#else
#define DEBUG(a)
#define DEBUG1(a)
#define DEBUG2(a)
#define DEBUG3(a)
#define DEBUG4(a)
#define DEBUG5(a)
#define TRACEALLOCS(a)
#define TRACEDELETER(a)
#define MAPALLOCS
#endif


#endif
