/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/

#include "stdafx.h"

#include <mmsystem.h>
#include <strstrea.h>

#include "email.h"
#include "mainfrm.h"
#include "mail.h"
#include "deldial.h"
#include "viewdial.h"
#include "message.h"
#include "emaildoc.h"

#ifdef LISTVIEW
#include "emlistvw.h" 
#endif


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

enum {TT_IDLE,TT_UPDATING,TT_VIEWING,TT_DELETING,TT_EXITING};


IMPLEMENT_DYNAMIC(CEmailHint, CObject)

CEmailHint::CEmailHint()
{
}

/////////////////////////////////////////////////////////////////////////////
// CEmailDoc

IMPLEMENT_DYNCREATE(CEmailDoc, CDocument)

BEGIN_MESSAGE_MAP(CEmailDoc, CDocument)
	//{{AFX_MSG_MAP(CEmailDoc)
	ON_COMMAND(ID_MAIL_DELETE, OnMailDelete)
	ON_COMMAND(ID_MAIL_VIEW, OnMailView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



HWND m_hwnd;



UINT UpdateThreadProc(LPVOID pParam)
{
::SetTimer(m_hwnd,ID_ANIMATE_TIMER,1000,NULL);
 unsigned nbmail;
 nbmail = ((CEmailDoc*)pParam)->GetMessages2(TRUE,FALSE);
 ::KillTimer(m_hwnd,ID_ANIMATE_TIMER);
 ::SendMessage(m_hwnd,WM_UPDATE_THREAD_FINISHED,nbmail,0);
 return 0;
}


UINT DeleteThreadProc(LPVOID pParam)
{
 ::SetTimer(m_hwnd,ID_ANIMATE_TIMER,1000,NULL);
 BOOL Return = ((CEmailDoc*)pParam)->MailDelete2();
 ::KillTimer(m_hwnd,ID_ANIMATE_TIMER);
 ::SendMessage(m_hwnd,WM_DELETE_THREAD_FINISHED,Return,0);
 return 0;
}


UINT ViewThreadProc(LPVOID pParam)
{
 ::SetTimer(m_hwnd,ID_ANIMATE_TIMER,1000,NULL);
 BOOL Return = ((CEmailDoc*)pParam)->MailView2();
 ::KillTimer(m_hwnd,ID_ANIMATE_TIMER);
 ::SendMessage(m_hwnd,WM_VIEW_THREAD_FINISHED,Return,0);
 return 0;
}


#if defined(WIN95) || defined(WINNT35)
UINT POPThread(LPVOID pParam)
{
 while (TRUE)
 {

  switch (((CEmailDoc*)pParam)->uTransferType)
   {
	case TT_UPDATING:
	    AfxGetPOPClient()->bCanceling = FALSE;
		UpdateThreadProc(pParam);
		break;
	case TT_VIEWING:
	    AfxGetPOPClient()->bCanceling = FALSE;
	    ViewThreadProc(pParam);
		break;
	case TT_DELETING:
	    AfxGetPOPClient()->bCanceling = FALSE;
	    DeleteThreadProc(pParam);
		break;
	case TT_EXITING:
        ((CEmailDoc*)pParam)->uTransferType = TT_IDLE;
		return 0;
		break;
    default:
		break;
   }
 ((CEmailDoc*)pParam)->uTransferType = TT_IDLE;
 ((CEmailDoc*)pParam)->wtPOPThread->SuspendThread();
 }
}
#endif




/////////////////////////////////////////////////////////////////////////////
// CEmailDoc construction/destruction

CEmailDoc::CEmailDoc()
{
  // TODO: add one-time construction code here
  mailselected = -1;
  bFirstTransfer = FALSE;
#if defined(WIN95) || defined(WINNT35)
  uTransferType = TT_IDLE;
  wtPOPThread = AfxBeginThread(POPThread,this,THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED);
#endif
}


int CEmailDoc::GetMailSelected() 
	  { 
#ifdef LISTVIEW
		return ((CEmailListView*)(AfxGetMainFrame()->GetActiveView()))->GetSelected();
#else
		return mailselected + 1; 
#endif
	  };


void CEmailDoc::DeleteMail()
{       
#ifndef WIN32
 CMail* cm;            
 unsigned maxindex = mail.GetSize();
 if (maxindex)
  {
   for (unsigned index=0;index<maxindex;index++)
    {
     cm = (CMail*)(mail.GetAt(index));
     if (cm) 
      delete cm;
    }
  }  
#endif
 mail.RemoveAll();
 mailselected = -1;
}



CEmailDoc::~CEmailDoc()
{
#if defined(WIN95) || defined(WINNT35)
	delete wtPOPThread;
#endif
	DeleteMail();
}

BOOL CEmailDoc::OnNewDocument()
{
  if (!CDocument::OnNewDocument())
		return FALSE;

  DeleteMail();
  UpdateAllViews(NULL);
  bFirstTransfer = FALSE;
  
  CString strmessage;
  if (strmessage.LoadString(IDS_MSG1_NOT_CHECKED))
   SetTitle(strmessage);
  return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CEmailDoc serialization

void CEmailDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}


#ifdef WIN32
int CEmailDoc::find(unsigned long size,unsigned start)
{
 for (unsigned index = start;index<GetMailNb();index++)
  {
   unsigned long size2 = mail.GetAt(index).GetSize();
   if ((size==size2)||(size==size2+1))
    return index;
  }
 return -1;
}
#endif
      
      
int CEmailDoc::GetMessages()
{
 m_hwnd = AfxGetMainFrame()->GetSafeHwnd();
#if defined(WIN95) || defined(WINNT35)
 uTransferType = TT_UPDATING;
 wtPOPThread->ResumeThread();	
#else
   AfxGetPOPClient()->bCanceling = FALSE;
   UpdateThreadProc((LPVOID)this);
#endif
 return 1;
}


extern CEmailApp theApp;



//
// Standard WIN32 updating method
//
int CEmailDoc::GetMessages2(BOOL bDisconnect,BOOL bReload)
{
 Progress(IDS_PROGRESS_CONNECTING,0);

 CPOPClient* popclient = AfxGetPOPClient();
 int oldmsg = GetMailNb();
 
 int messages = popclient->POPConnect();

 int number = -1;
 if ((messages==-1)||((oldmsg==messages)&&(!bReload))) 
  {
   Progress(IDS_PROGRESS_DISCONNECTING,95);
   popclient->POPDisconnect(messages);
   return messages;
  }
 

#ifdef WIN32
 // Array for newmail
 CArray<CMail, CMail&> oldmail;
#else
 CObArray oldmail;
#endif


 BOOL NewMail = FALSE;
 int Problem = 1;

 // Backup Mail in oldmail
 // Will be used to compare
 for (unsigned index = 0;index<(unsigned)mail.GetSize();index++)
   {
#ifdef WIN32
    CMail nmail = mail[index];
	oldmail.Add(nmail);
#else
    oldmail.Add(new CMail(*(CMail*)mail.GetAt(index)));
#endif
   }

 // Delete Mail
 DeleteMail();
 
 // Update Mail
 if (messages>0)
  {
   for (number=1;number<=messages;number++)
	{
	 CMail nmail;
  	 Progress(IDS_PROGRESS_HEADER,10+80*(number-1)/messages);
  	 if (popclient->GetMessageHeader(number,nmail)<=0)
	  {
		Progress(IDS_PROGRESS_DISCONNECTING,95);
		popclient->POPDisconnect(-1);
		DeleteMail();
		
		for (unsigned index = 0;index<(unsigned)oldmail.GetSize();index++)
   			{
#ifdef WIN32
    		CMail nmail = oldmail[index];
			mail.Add(nmail);
#else
            mail.Add(new CMail(*(CMail*)oldmail.GetAt(index)));
#endif
   			}
		return -1;
	  }            
#ifdef WIN32	  
     mail.Add(nmail);
#else
     mail.Add(new CMail(nmail));
#endif     
	 AfxGetMainFrame()->SendMessage(WM_MAIL_DOWNLOAD,0,0);
	}
   }
			  
 Progress(IDS_PROGRESS_MAIL_SIZES,90);
 unsigned long* sizes = new unsigned long[messages];
 unsigned sizeres = popclient->POPGetSizes(sizes,messages);
 if (sizeres>0)
   for (int i=0;i<messages;i++)
#ifdef WIN32
    mail[i].SetSize(sizes[i]);
#else
    ((CMail*)mail.GetAt(i))->SetSize(sizes[i]);
#endif
 delete[] sizes;



 Progress(IDS_PROGRESS_DISCONNECTING,90);
 popclient->POPDisconnect(messages);

 Progress(IDS_PROGRESS_SEARCHING_NEWMAIL,95);
 // Compare mail with oldmail
 // to see if there is anything new
 int index1 = 0;
 int index2 = 0;
 
 while ((index1<messages)&&(index2<oldmsg))
    {
	 if (mail.GetAt(index1)==oldmail.GetAt(index2))
	  {
	   index1++;
	  }
	 index2++;
	}
  if (index1<messages)
  {
   if (AfxGetConfig()->m_bNOTIFYWav)	
     sndPlaySound(AfxGetConfig()->m_csNOTIFYWave,SND_ASYNC);
    if ( AfxGetConfig()->m_bNOTIFYSpeaker)	
  	 MessageBeep(0xFFFFFFFF);
    if ((bFirstTransfer||(!AfxGetConfig()->m_bNOTIFYSpawnNotFirst))
		 &&(AfxGetConfig()->m_bNOTIFYSpawn))
	 {
	  if (WinExec(Substitute(AfxGetConfig()->m_csNOTIFYSpawnProgram),SW_SHOW)<=31)
	   if (AfxGetConfig()->m_bUIMsgBoxOnError)
	    NotifyMessageBox(IDS_SPAWN_PROGRAM_ERROR);
	 }
    else
	 {
	  bFirstTransfer = TRUE;
	 }

     if (AfxGetConfig()->m_bNOTIFYMsgBox)
      NotifyMessageBox(IDS_NEW_MAIL);
	 return messages;
  }

 return messages;
}




int CEmailDoc::MailDelete2()
{
 int mailnb = mailtodelete - 1;

 CString smail;
 CString strAuthor,strSubject,strDate;
 unsigned long ulSize;
 GetMail(mailnb,strAuthor,strSubject,strDate,ulSize);
 

#ifndef WIN16
 AfxGetMainFrame()->SetForegroundWindow();
#endif

 CDeleteDialog ddialog(AfxGetMainFrame(),strAuthor,strDate,strSubject,ulSize);
 if (ddialog.DoModal()!=IDYES)
  {
   AfxGetPOPClient()->bCanceling = TRUE;
   return 0;
  }

 Progress(IDS_PROGRESS_CONNECTING,0);
 CPOPClient* popclient = AfxGetPOPClient();
 
 int messages = popclient->POPConnect();

 int number = -1;
 if (messages==-1) 
  {
   Progress(IDS_PROGRESS_DISCONNECTING,95);
   popclient->POPDisconnect(-1);
   return FALSE;
  }
 
 int Problem = 1;


 // Find Mail to Delete
 if (messages>0)
  {
    int start;
	if (messages>mailnb+1)
	 start = mailnb+1;
    else
     start = messages;

   for (number=start;number>0;number--)
	{
	 Progress(IDS_PROGRESS_SEARCHING,10+80*(number-1)/(start+1));
  	 CMail nmail;
  	 if (popclient->GetMessageHeader(number,nmail)<=0)
	  {
   	    Progress(IDS_PROGRESS_DISCONNECTING,95);
	  	popclient->POPDisconnect(-1);
		return FALSE;
	  }            

#ifdef WIN32
     if (nmail==mail.GetAt(mailnb))
#else
     if (nmail==(*(CMail*)(mail.GetAt(mailnb))))
#endif
     break;   
	}
   }

 if (number==0)
  {
   Progress(IDS_PROGRESS_DISCONNECTING,95);
   popclient->POPDisconnect(-1);
   NotifyMessageBox(IDS_ERROR_FINDMAIL);
   return FALSE;
  }			  

 Progress(IDS_PROGRESS_DELETE,90);
 BOOL Return = popclient->DeleteMail(number);
 
 Progress(IDS_PROGRESS_DISCONNECTING,95);
 popclient->POPDisconnect(messages);
 
 if (Return)
  {
   mail.RemoveAt(mailnb);
  }

 return Return;
}
    

int CEmailDoc::MailView2()
{
 int mailnb = mailtoview-1;
 CPOPClient* popclient = AfxGetPOPClient();
 

 Progress(IDS_PROGRESS_CONNECTING,0);
 int messages = popclient->POPConnect();

 int number = -1;
 if (messages==-1) 
  {
   Progress(IDS_PROGRESS_DISCONNECTING,95);
   popclient->POPDisconnect(-1);
   return FALSE;
  }
 
 int Problem = 1;


 // Find Mail to View
 if (messages>0)
  {
    int start;
	if (messages>mailnb+1)
	 start = mailnb+1;
    else
     start = messages;

    for (number=start;number>0;number--)
	{
	 Progress(IDS_PROGRESS_SEARCHING,10+80*(number-1)/(start+1));
  	 CMail nmail;
  	 if (popclient->GetMessageHeader(number,nmail)<=0)
	  {
        Progress(IDS_PROGRESS_DISCONNECTING,95);
       	popclient->POPDisconnect(-1);
		return FALSE;
	  }            

#ifdef WIN32
     if (nmail==mail.GetAt(mailnb))
#else
     if (nmail==(*(CMail*)(mail.GetAt(mailnb))))
#endif
     break;   
	}
   }

 if (number==0)
  {
   Progress(IDS_PROGRESS_DISCONNECTING,95);
   popclient->POPDisconnect(-1);
   NotifyMessageBox(IDS_ERROR_FINDMAIL);
   return FALSE;
  }			  

 CString strMail;
 CString strAuthor,strSubject,strDate;
 unsigned long ulSize;
 
 GetMail(mailnb,strAuthor,strSubject,strDate,ulSize);
 
 
 Progress(IDS_PROGRESS_MAIL,30);
 BOOL Return = popclient->ViewMail(number,strMail,ulSize);
 
 
 Progress(IDS_PROGRESS_DISCONNECTING,95);
 popclient->POPDisconnect(messages);
 
#ifndef WIN16
 AfxGetMainFrame()->SetForegroundWindow();
#endif 
 
 CViewDialog vdialog(AfxGetMainFrame(),strAuthor,strDate,strSubject,ulSize,strMail);
 vdialog.DoModal();

 return Return;
}



void CEmailDoc::GetMail(UINT nMail,CString& strAuthor,CString& strSubject,CString& strDate,unsigned long& ulSize)
{
  if ((int)nMail<mail.GetSize())
#ifndef WIN32
   ((CMail*)mail[nMail])->GetMail(strAuthor,strSubject,strDate,ulSize);
#else
   mail[nMail].GetMail(strAuthor,strSubject,strDate,ulSize);
#endif
}

#ifndef LISTVIEW
void CEmailDoc::ChangeSelectionNext(BOOL bNext)
{
  if (bNext==FALSE) 
   {
	if (mailselected>0) 
	 {
	  CEmailHint hint;
	  UpdateAllViews(NULL, MAKELONG(--mailselected, 0), &hint);
	 }
   }
  else
   {
	if ((int)mailselected<mail.GetSize()-1) 
	 {
	  CEmailHint hint;
	  UpdateAllViews(NULL, MAKELONG(++mailselected, 0), &hint);
	 }
   }
}


void CEmailDoc::ChangeSelectionTo(unsigned nRow)
{
  if ((nRow>=0)&&((int)nRow<mail.GetSize()))
   {
	mailselected = nRow;
	
	CEmailHint hint;
	UpdateAllViews(NULL, MAKELONG(mailselected, 0), &hint);
   }
}
#endif
 

CString CEmailDoc::Substitute(CString cmdline)
{
 CString new_cmdline;

 unsigned pos = 0;
 unsigned length = cmdline.GetLength();

 while (pos<length)
  {
   switch (cmdline.GetAt(pos))
    {
     case '%':
	  {
	   if (pos+1==length)	
        {
         return new_cmdline;
	    }
	   else
	    switch (cmdline.GetAt(pos+1))
		 {
          case '%':
           new_cmdline += '%';
           pos+=2;		   
 		   break;	
		  case 'n':
		   {
		    char buffer[20];
			sprintf(buffer,"%u",GetMailNb());
		    new_cmdline += buffer;
		    pos+=2;
       	   }
       	   break;	
	      default:
		   pos+=2;
		   break;
		 }
       break;
 	  }
    default:
     new_cmdline += cmdline.GetAt(pos);
	 pos++;
	 break;	
    }
  }

 return new_cmdline;
}

/////////////////////////////////////////////////////////////////////////////
// CEmailDoc diagnostics

#ifdef _DEBUG
void CEmailDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CEmailDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEmailDoc commands


int CEmailDoc::Downloading()
{
 return AfxGetMainFrame()->Downloading();
}


void CEmailDoc::MailDelete() 
{
 m_hwnd = AfxGetMainFrame()->GetSafeHwnd();
 mailtodelete = GetMailSelected();
#if defined(WIN95) || defined(WINNT35)
 uTransferType = TT_DELETING;
 wtPOPThread->ResumeThread();	
#else
   AfxGetPOPClient()->bCanceling = FALSE;
   DeleteThreadProc((LPVOID)this);
#endif
}


void CEmailDoc::MailView() 
{
 m_hwnd = AfxGetMainFrame()->GetSafeHwnd();
 mailtoview = GetMailSelected();
#if defined(WIN95) || defined(WINNT35)
 uTransferType = TT_VIEWING;
 wtPOPThread->ResumeThread();	
#else
   AfxGetPOPClient()->bCanceling = FALSE;
   ViewThreadProc((LPVOID)this);
#endif
}


void CEmailDoc::OnMailDelete() 
{
 AfxGetMainFrame()->OnMailDelete();
}

void CEmailDoc::OnMailView() 
{
 AfxGetMainFrame()->OnMailView();
}


void CEmailDoc::Progress(UINT MessageCode,unsigned Progress)
{
 AfxGetMainFrame()->SendMessage(WM_NOTIFY_PROGRESS,MessageCode,Progress);
}



