/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/

 //
 // Win32 View Implementation
 //

#include "stdafx.h"
#include "email.h"
#include "emaildoc.h"
#include "emlistvw.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CEmailListView

IMPLEMENT_DYNCREATE(CEmailListView, CListView)

CEmailListView::CEmailListView()
{
}

CEmailListView::~CEmailListView()
{
}


BEGIN_MESSAGE_MAP(CEmailListView, CListView)
	//{{AFX_MSG_MAP(CEmailListView)
	ON_WM_CREATE()
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnclick)
	ON_COMMAND(ID_LISTVIEW_FONT, OnListviewFont)
	ON_NOTIFY_REFLECT(NM_RCLICK, OnRClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

////
/////////////////////////////////////////////////////////////////////////
// CEmailListView drawing

void CEmailListView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CEmailListView diagnostics

#ifdef _DEBUG
void CEmailListView::AssertValid() const
{
	CListView::AssertValid();
}

void CEmailListView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEmailListView message handlers

void CEmailListView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
 CListCtrl& ctlList = (CListCtrl&) GetListCtrl();
 
 ctlList.DeleteAllItems();

 for (unsigned i = 0;i < GetDocument()->GetMailNb();i++)
  AddMail(i);
}


int CEmailListView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style |= LVS_REPORT | LVS_SINGLESEL;
	
	if (CListView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	
	CListCtrl& ctlList = (CListCtrl&) GetListCtrl();
	CString strListView = AfxGetConfig()->m_csUIListViewPos;
	UINT uPos = 0;
   
    uPos = strListView.Find(_T(","));
	ctlList.InsertColumn(1,"Author",LVCFMT_LEFT,atoi(strListView.Left(uPos)));
	strListView = strListView.Mid(uPos + 1);

    uPos = strListView.Find(_T(","));
	ctlList.InsertColumn(2,"Subject",LVCFMT_LEFT,atoi(strListView.Left(uPos)));
	strListView = strListView.Mid(uPos + 1);
    

	uPos = strListView.Find(_T(","));
	ctlList.InsertColumn(3,"Date",LVCFMT_LEFT,atoi(strListView.Left(uPos)));

	ctlList.InsertColumn(4,"Size",LVCFMT_LEFT,atoi(strListView.Mid(uPos + 1)));

    CString strListViewFont = AfxGetConfig()->m_csUIListViewFont;
    if (strListViewFont=="")
	 {
	 cfFont.CreateFont(14,0,0,0,FW_NORMAL,0,0,0,0,0,0,PROOF_QUALITY,0,"Times New Roman");
	 ctlList.SetFont(&cfFont,TRUE);
	 }
    else
	 {
	  UINT uPos = 0;
      CString strFaceName;
	  UINT uHeight,uWidth,uWeight,uItalic;
	  
	  uPos = strListViewFont.Find(_T(","));
	  strFaceName = strListViewFont.Left(uPos);
	  strListViewFont = strListViewFont.Mid(uPos + 1);
	  uPos = strListViewFont.Find(_T(","));
	  uHeight = atoi(strListViewFont.Left(uPos)); 
	  strListViewFont = strListViewFont.Mid(uPos + 1);
	  uPos = strListViewFont.Find(_T(","));
	  uWidth = atoi(strListViewFont.Left(uPos)); 
	  strListViewFont = strListViewFont.Mid(uPos + 1);
	  uPos = strListViewFont.Find(_T(","));
	  uWeight = atoi(strListViewFont.Left(uPos)); 
	  uItalic = atoi(strListViewFont.Mid(uPos + 1));
	
	  cfFont.CreateFont(uHeight,uWidth,0,0,uWeight,uItalic,0,0,0,0,0,PROOF_QUALITY,0,strFaceName);
	  ctlList.SetFont(&cfFont,TRUE);
	
	}

	return 0;
}

void CEmailListView::AddMail(UINT uRow)
{
	CListCtrl& ctlList = (CListCtrl&) GetListCtrl();

	
	// Get the data for the specific Mail.
	CString strAuthor, strSubject, strDate, strItem;
	unsigned long ulSize;

	GetDocument()->GetMail(uRow, strAuthor, strSubject, strDate, ulSize);

	char sbuffer[100];
	sprintf(sbuffer,"%lu bytes",ulSize);

 	UINT uPos = ctlList.InsertItem(LVIF_TEXT,uRow,strAuthor.GetBuffer(0),0,0,0,0);
	ctlList.SetItem(uPos,1,LVIF_TEXT,strSubject.GetBuffer(0),0,0,0,0);
	ctlList.SetItem(uPos,2,LVIF_TEXT,strDate.GetBuffer(0),0,0,0,0);
	ctlList.SetItem(uPos,3,LVIF_TEXT,sbuffer,0,0,0,0);
}

void CEmailListView::OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
}

void CEmailListView::OnListviewFont() 
{
	// TODO: Add your command handler code here
	LOGFONT lfFont;
	
	cfFont.GetLogFont(&lfFont);
	CFontDialog cfdDialog(&lfFont,CF_SCREENFONTS | CF_ENABLETEMPLATE | CF_NOSCRIPTSEL);
    cfdDialog.m_cf.hInstance = AfxGetApp()->m_hInstance;
	cfdDialog.m_cf.lpTemplateName = MAKEINTRESOURCE(IDD_FONTSELECTION);

	if (cfdDialog.DoModal()==IDOK);
	{
	 CString strListViewFont;

	 cfdDialog.GetCurrentFont(&lfFont);
	 cfFont.DeleteObject();
	 cfFont.CreateFontIndirect(&lfFont);
	 GetListCtrl().SetFont(&cfFont,TRUE);
	 Invalidate();

     char sbuffer[100];
	 sprintf(sbuffer,"%s,%d,%d,%d,%d",lfFont.lfFaceName,lfFont.lfHeight,
					 lfFont.lfWidth,lfFont.lfWeight,lfFont.lfItalic);

	 AfxGetConfig()->m_csUIListViewFont = sbuffer;
	 AfxGetConfig()->SaveProfileString();
	
	}
}

void CEmailListView::OnRClick(NMHDR* pNMHDR, LRESULT* pResult) 
{
 if ((GetDocument()->Downloading()==0)&&(GetSelected()>0))
  {
   POINT pCursor;
   CMenu popup;
		 	
   GetCursorPos(&pCursor);
		 										
#ifndef FREEWARE
 if (!popup.LoadMenu(IDR_POPUP_MENU))
   AfxThrowResourceException();	
#else
 if (!popup.LoadMenu(IDR_POPUP_MENU_FW))
   AfxThrowResourceException();	
#endif
 
   CMenu* pMenu = popup.GetSubMenu(1);
   pMenu->TrackPopupMenu(TPM_RIGHTALIGN | TPM_RIGHTBUTTON,
                        pCursor.x,pCursor.y,this,NULL);
   popup.DestroyMenu();
  } 	    
 *pResult = 0;
}

int CEmailListView::GetSelected()
{
 CListCtrl& ctlList = (CListCtrl&) GetListCtrl();
 return ctlList.GetNextItem(-1,LVNI_SELECTED) + 1;
}

void CEmailListView::SaveColumnPreferences()
{
 CListCtrl& ctlList = (CListCtrl&) GetListCtrl();

 char sbuffer[100];
 sprintf(sbuffer,"%d,%d,%d,%d",ctlList.GetColumnWidth(0),ctlList.GetColumnWidth(1),
								ctlList.GetColumnWidth(2),ctlList.GetColumnWidth(3));

 AfxGetConfig()->m_csUIListViewPos =  sbuffer;
}

