/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/

#include "stdafx.h"
#include "email.h"
#include "logodial.h"
#include "idhindex.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLogoDialog dialog


CLogoDialog::CLogoDialog(int iRunsLeft,CWnd* pParent /*=NULL*/)
	: CDialog(CLogoDialog::IDD, pParent)
{
 char cBuffer[10];
 if (iRunsLeft>0)
  sprintf(cBuffer,"%u",iRunsLeft);
 else
  strcpy(cBuffer,"no");

 //{{AFX_DATA_INIT(CLogoDialog)
 m_csRunsLeft = cBuffer;
 //}}AFX_DATA_INIT
}


void CLogoDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLogoDialog)
	DDX_Text(pDX, IDC_STATIC_DAYSLEFT, m_csRunsLeft);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLogoDialog, CDialog)
	//{{AFX_MSG_MAP(CLogoDialog)
	ON_BN_CLICKED(ID_HELP_REGISTER, OnRegister)
	ON_BN_CLICKED(ID_WWW_REGISTER, OnWwwRegister)
	ON_BN_CLICKED(ID_HELP_REGISTRATION, OnHelpRegistration)
	ON_BN_CLICKED(ID_HELP_APPLY_REG, OnHelpApplyReg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CLogoDialog message handlers

void CLogoDialog::OnRegister() 
{
 AfxGetEmailApp()->OnHelpRegister();
}

BOOL CLogoDialog::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	DWORD dwResult = CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
    
	if (dwResult)
	 {
      RECT wrect;
      GetWindowRect(&wrect);
      UINT width = wrect.right - wrect.left;
  	  UINT height = wrect.bottom - wrect.top;
  	  UINT swidth = GetSystemMetrics(SM_CXSCREEN);
  	  UINT sheight = GetSystemMetrics(SM_CYSCREEN);

	  wrect.left = (swidth - width) / 2;
  	  wrect.top = (sheight - height)/2;
      wrect.right = wrect.left + width;
      wrect.bottom = wrect.top + height;

  	  MoveWindow(&wrect,TRUE);
      ShowWindow(SW_SHOW);
	 }

 return dwResult;
}

void CLogoDialog::OnWwwRegister() 
{
CString strmessage;
 if (strmessage.LoadString(IDS_WWW_REGISTER))
   AfxGetEmailApp()->ShowWebPage(strmessage);
 else
   AfxMessageBox("Internal Error");
}

void CLogoDialog::OnHelpRegistration() 
{
 AfxGetApp()->WinHelp(IDH_REGISTER);
}

void CLogoDialog::OnHelpApplyReg() 
{
 AfxGetApp()->WinHelp(IDH_HELP_APPLY_REG);
}
