/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#include "stdafx.h"
#include "email.h"
#include "ppopt1.h"
#include "popclien.h"
#include "idhindex.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


static DWORD Mapping[] = 
 {
	IDC_CHECK_ON_STARTUP, IDH_CHECKING_STARTUP,
	IDC_START_HIDDEN,IDH_STARTHIDDEN,
	IDC_ENABLE_CHECK,IDH_CHECKING_ENABLE,
	IDC_MINUTES, IDH_CHECKING_TIME,
	IDC_SECONDS, IDH_CHECKING_TIME
 };


/////////////////////////////////////////////////////////////////////////////
// CPPOpt1 property page

IMPLEMENT_DYNCREATE(CPPOpt1, CPropertyPage)

CPPOpt1::CPPOpt1() : CPropertyPage(CPPOpt1::IDD)
{
	CPOPClient* popclient = AfxGetPOPClient();

	//{{AFX_DATA_INIT(CPPOpt1)
	m_check_on_startup = AfxGetConfig()->m_bCHECKOnStartup;
	m_enable_check = AfxGetConfig()->m_bCHECKAutoNotify;
	m_minutes = div(AfxGetConfig()->m_uCHECKTime,60).quot;
	m_seconds = div(AfxGetConfig()->m_uCHECKTime,60).rem;
	m_start_hidden = AfxGetConfig()->m_bUIStartHidden;
	//}}AFX_DATA_INIT
}

CPPOpt1::~CPPOpt1()
{
}

void CPPOpt1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPOpt1)
	DDX_Check(pDX, IDC_CHECK_ON_STARTUP, m_check_on_startup);
	DDX_Check(pDX, IDC_ENABLE_CHECK, m_enable_check);
	DDX_Text(pDX, IDC_MINUTES, m_minutes);
	DDV_MinMaxUInt(pDX, m_minutes, 0, 1000);
	DDX_Text(pDX, IDC_SECONDS, m_seconds);
	DDV_MinMaxUInt(pDX, m_seconds, 0, 60);
	DDX_Check(pDX, IDC_START_HIDDEN, m_start_hidden);
	//}}AFX_DATA_MAP
}


void CPPOpt1::UpdatePOPClientFromPage()
{
  AfxGetConfig()->m_bCHECKOnStartup = m_check_on_startup;
  AfxGetConfig()->m_bCHECKAutoNotify = m_enable_check;
  AfxGetConfig()->m_uCHECKTime = m_minutes*60+m_seconds;
  AfxGetConfig()->m_bUIStartHidden = m_start_hidden;
}

BEGIN_MESSAGE_MAP(CPPOpt1, CPropertyPage)
	//{{AFX_MSG_MAP(CPPOpt1)
	ON_BN_CLICKED(IDC_ENABLE_CHECK, OnEnableCheck)
	ON_BN_CLICKED(IDC_CHECK_ON_STARTUP, OnEnableCheck)
	ON_EN_CHANGE(IDC_MINUTES, OnEnableCheck)
	ON_EN_CHANGE(IDC_SECONDS, OnEnableCheck)
	ON_BN_CLICKED(IDC_START_HIDDEN, OnEnableCheck)
	//}}AFX_MSG_MAP
#ifdef WIN32
	ON_MESSAGE(WM_HELP,OnHelp)
    ON_MESSAGE(WM_CONTEXTMENU,OnContextMenu)
#endif
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPPOpt1 message handlers

void CPPOpt1::OnEnableCheck() 
{
 SetModified(TRUE);
}


#ifdef WIN32
LONG CPPOpt1::OnHelp(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)((HELPINFO*)lParam)->hItemHandle,AfxGetApp()->m_pszHelpFilePath,HELP_WM_HELP,(DWORD)&Mapping);
}


LONG CPPOpt1::OnContextMenu(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)wParam,AfxGetApp()->m_pszHelpFilePath,HELP_CONTEXTMENU,(DWORD)&Mapping);
}
#endif


