/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#include "stdafx.h"
#include "email.h"
#include "ppopt4.h"
#include "popclien.h"
#include "idhindex.h"
#include <iostream.h>
#include <fstream.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPOpt4 property page

IMPLEMENT_DYNCREATE(CPPOpt4, CPropertyPage)


static DWORD Mapping[] = 
 {
  IDC_BROWSE_LOGFILE, IDH_BROWSE,
  IDC_EDIT_LOGFILE,	IDH_LOGFILENAME,
  IDC_LOG_FILE,	IDH_LOGREQUEST,
  IDC_MESSAGE_BOX, IDH_MSGBOXONERRORS
 };



CPPOpt4::CPPOpt4() : CPropertyPage(CPPOpt4::IDD)
{
	//{{AFX_DATA_INIT(CPPOpt4)
	m_edit_logfile = AfxGetConfig()->m_csLOGFilename;
	m_log = AfxGetConfig()->m_bLOGLogging;
	m_verbose = AfxGetConfig()->m_bLOGVerbose;
	m_msg_box_on_error = AfxGetConfig()->m_bUIMsgBoxOnError;
	//}}AFX_DATA_INIT
}

CPPOpt4::~CPPOpt4()
{
}

void CPPOpt4::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPOpt4)
	DDX_Text(pDX, IDC_EDIT_LOGFILE, m_edit_logfile);
	DDX_Check(pDX, IDC_LOG_FILE, m_log);
	DDX_Check(pDX, IDC_MESSAGE_BOX, m_msg_box_on_error);
	DDX_Check(pDX, IDC_VERBOSE, m_verbose);
	//}}AFX_DATA_MAP
}



void CPPOpt4::UpdatePOPClientFromPage()
{
  CPOPClient* popclient = AfxGetPOPClient();
  
  AfxGetConfig()->m_csLOGFilename = m_edit_logfile;
  AfxGetConfig()->m_bLOGLogging = m_log;
  AfxGetConfig()->m_bLOGVerbose = m_verbose;
 
  AfxGetConfig()->m_bUIMsgBoxOnError =  m_msg_box_on_error;
}



BEGIN_MESSAGE_MAP(CPPOpt4, CPropertyPage)
	//{{AFX_MSG_MAP(CPPOpt4)
	ON_BN_CLICKED(IDC_BROWSE_LOGFILE, OnBrowseLogfile)
	ON_EN_CHANGE(IDC_EDIT_LOGFILE, OnPageChanged)
	ON_BN_CLICKED(IDC_LOG_FILE, OnPageChanged)
	ON_BN_CLICKED(IDC_MESSAGE_BOX, OnPageChanged)
	ON_BN_CLICKED(IDC_VERBOSE, OnPageChanged)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	//}}AFX_MSG_MAP
#ifdef WIN32
	ON_MESSAGE(WM_HELP,OnHelp)
    ON_MESSAGE(WM_CONTEXTMENU,OnContextMenu)
#endif
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPPOpt4 message handlers

void CPPOpt4::OnBrowseLogfile() 
{
 UpdateData(TRUE);
 OPENFILENAME ofn;
 memset(&ofn, 0, sizeof(ofn));

 ofn.lStructSize=sizeof(ofn);
 ofn.hwndOwner = GetSafeHwnd();
 ofn.lpstrFilter = "Log Files\0*.log";
 ofn.lpstrCustomFilter = NULL;
 ofn.nFilterIndex = 0;
 ofn.lpstrFile = new char[255];
 strncpy(ofn.lpstrFile,"",255);
 ofn.nMaxFile = 255;
 ofn.lpstrFileTitle = "Choose a file to save Log information";
 ofn.lpstrInitialDir = NULL;
 ofn.Flags = OFN_HIDEREADONLY;
 #ifdef WIN95
 ofn.Flags |= OFN_EXPLORER;
 #endif

 if (GetOpenFileName(&ofn))
   { 
    m_edit_logfile = ofn.lpstrFile;
    SetModified(TRUE);	
    UpdateData(FALSE);
   }
 delete[] ofn.lpstrFile;
}


void CPPOpt4::OnPageChanged() 
{
 SetModified(TRUE);	
}

#ifdef WIN32
LONG CPPOpt4::OnHelp(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)((HELPINFO*)lParam)->hItemHandle,AfxGetApp()->m_pszHelpFilePath,HELP_WM_HELP,(DWORD)&Mapping);
}


LONG CPPOpt4::OnContextMenu(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)wParam,AfxGetApp()->m_pszHelpFilePath,HELP_CONTEXTMENU,(DWORD)&Mapping);
}           
#endif

void CPPOpt4::OnReset() 
{
	// TODO: Add your control notification handler code here
  UpdateData(TRUE);
  ofstream logfile;
  logfile.open(m_edit_logfile, ios::out | ios::trunc);
   
  if (logfile.is_open())
   logfile.close();
  else
   AfxMessageBox(IDS_ERROR_LOGFILE);
}
