/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#include "stdafx.h"
#include "email.h"
#include "ppopt5.h"
#include "popclien.h"
#include "idhindex.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPOpt5 property page

IMPLEMENT_DYNCREATE(CPPOpt5, CPropertyPage)


static DWORD Mapping[] = 
 {
	IDC_EDIT_READER, IDH_EXTERNAL,
	IDC_READER_BROWSE, IDH_BROWSE,
	IDC_SPAWN_BROWSE, IDH_BROWSE,
	IDC_SPAWN, IDH_SPAWN,
	IDC_SPAWN_NOT1, IDH_SPAWNNOT1
 };



CPPOpt5::CPPOpt5() : CPropertyPage(CPPOpt5::IDD)
{
	CPOPClient* popclient = AfxGetPOPClient();

	//{{AFX_DATA_INIT(CPPOpt5)
	m_edit_reader = AfxGetConfig()->m_csNOTIFYMailReader;
	m_edit_spawn = AfxGetConfig()->m_csNOTIFYSpawnProgram;
	m_spawn = AfxGetConfig()->m_bNOTIFYSpawn;
	m_spawn_not1 = AfxGetConfig()->m_bNOTIFYSpawnNotFirst;
	//}}AFX_DATA_INIT
}

CPPOpt5::~CPPOpt5()
{
}

void CPPOpt5::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPOpt5)
	DDX_Text(pDX, IDC_EDIT_READER, m_edit_reader);
	DDX_Text(pDX, IDC_EDIT_SPAWN, m_edit_spawn);
	DDX_Check(pDX, IDC_SPAWN, m_spawn);
	DDX_Check(pDX, IDC_SPAWN_NOT1, m_spawn_not1);
	//}}AFX_DATA_MAP
}


void CPPOpt5::UpdatePOPClientFromPage()
{
  AfxGetConfig()->m_csNOTIFYMailReader = m_edit_reader;
  AfxGetConfig()->m_csNOTIFYSpawnProgram = m_edit_spawn;
  AfxGetConfig()->m_bNOTIFYSpawn = m_spawn;
  AfxGetConfig()->m_bNOTIFYSpawnNotFirst  = m_spawn_not1;
}


BEGIN_MESSAGE_MAP(CPPOpt5, CPropertyPage)
	//{{AFX_MSG_MAP(CPPOpt5)
	ON_EN_CHANGE(IDC_EDIT_READER, OnPageChanged)
	ON_BN_CLICKED(IDC_READER_BROWSE, OnReaderBrowse)
	ON_BN_CLICKED(IDC_SPAWN_BROWSE, OnSpawnBrowse)
	ON_BN_CLICKED(IDC_SPAWN, OnSpawn)
	ON_BN_CLICKED(IDC_SPAWN_NOT1, OnSpawn)
	//}}AFX_MSG_MAP
#ifdef WIN32
	ON_MESSAGE(WM_HELP,OnHelp)
    ON_MESSAGE(WM_CONTEXTMENU,OnContextMenu)
#endif
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPPOpt5 message handlers

void CPPOpt5::OnPageChanged() 
{
 SetModified(TRUE);
}



void CPPOpt5::OnReaderBrowse() 
{
 UpdateData(TRUE);
 OPENFILENAME ofn;
 memset(&ofn, 0, sizeof(ofn));

 ofn.lStructSize=sizeof(ofn);
 ofn.hwndOwner = GetSafeHwnd();
 ofn.lpstrFilter = "Applications\0*.exe";
 ofn.lpstrCustomFilter = NULL;
 ofn.nFilterIndex = 0;
 ofn.lpstrFile = new char[255];
 strncpy(ofn.lpstrFile,"",255);
 ofn.nMaxFile = 255;
 ofn.lpstrFileTitle = "Choose an externel mail reader";
 ofn.lpstrInitialDir = NULL;
 ofn.Flags = OFN_HIDEREADONLY;
 #ifdef WIN95
 ofn.Flags |= OFN_EXPLORER;
 #endif

 if (GetOpenFileName(&ofn))
  {
   m_edit_reader = ofn.lpstrFile;
   SetModified(TRUE);
   UpdateData(FALSE);
  }	
 delete[] ofn.lpstrFile;
}

void CPPOpt5::OnSpawnBrowse() 
{
 UpdateData(TRUE);
 OPENFILENAME ofn;
 memset(&ofn, 0, sizeof(ofn));

 ofn.lStructSize=sizeof(ofn);
 ofn.hwndOwner = GetSafeHwnd();
 ofn.lpstrFilter = "Applications\0*.exe";
 ofn.lpstrCustomFilter = NULL;
 ofn.nFilterIndex = 0;
 ofn.lpstrFile = new char[255];
 strncpy(ofn.lpstrFile,"",255);
 ofn.nMaxFile = 255;
 ofn.lpstrFileTitle = "Choose a program to spawn on new mail";
 ofn.lpstrInitialDir = NULL;
 ofn.Flags = OFN_HIDEREADONLY;
 #ifdef WIN95
 ofn.Flags |= OFN_EXPLORER;
 #endif

 if (GetOpenFileName(&ofn))
  {
   m_edit_spawn = ofn.lpstrFile;
   SetModified(TRUE);
   UpdateData(FALSE);
  }	
 delete[] ofn.lpstrFile;
}


void CPPOpt5::OnSpawn() 
{
 SetModified(TRUE);
}

#ifdef WIN32
LONG CPPOpt5::OnHelp(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)((HELPINFO*)lParam)->hItemHandle,AfxGetApp()->m_pszHelpFilePath,HELP_WM_HELP,(DWORD)&Mapping);
}


LONG CPPOpt5::OnContextMenu(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)wParam,AfxGetApp()->m_pszHelpFilePath,HELP_CONTEXTMENU,(DWORD)&Mapping);
}
#endif            
            