/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#include "stdafx.h"
#include "email.h"
#include "ppopt6.h"
#include "popclien.h"
#include "Logon.h"
#include "idhindex.h"
#include "ras.h"
#include "rasinit.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPOpt6 PropertyPage


IMPLEMENT_DYNCREATE(CPPOpt6, CPropertyPage)


static DWORD Mapping[] = 
 {
IDC_EDITENTRY,IDH_RA_EDITENTRY,
IDC_LOGONAS,IDH_RA_LOGONAS,
IDC_NEWENTRY,IDH_RA_NEWENTRY,
IDC_REMOTE_ASK,IDH_RA_ASKDISCONNECT,
IDC_REMOTE_DIALIN,IDH_RA_DIALIN,
IDC_REMOTE_MONITOR,IDH_RA_MONITOR,
IDC_REMOTE_TIME,IDH_RA_TIME,
IDC_SERVICELIST,IDH_RA_SERVICELIST
 };





CPPOpt6::CPPOpt6()
	: CPropertyPage(CPPOpt6::IDD)
{
	CPOPClient* popclient = AfxGetPOPClient();

	//{{AFX_DATA_INIT(CPPOpt6)
	m_service = AfxGetConfig()->m_csRAService;
	m_remote_ask = AfxGetConfig()->m_bRAAskDisconnect;
	m_remote_dialin = AfxGetConfig()->m_bRADialIn;
	m_remote_monitor = AfxGetConfig()->m_bRAMonitor;
	m_remote_time = AfxGetConfig()->m_uRATime;
	//}}AFX_DATA_INIT
  }


void CPPOpt6::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPOpt6)
	DDX_Control(pDX, IDC_REMOTE_TIME, m_remote_time_edit);
	DDX_Control(pDX, IDC_REMOTE_MONITOR, m_remote_monitor_checkbox);
	DDX_Control(pDX, IDC_REMOTE_DIALIN, m_remote_dialin_checkbox);
	DDX_Control(pDX, IDC_REMOTE_ASK, m_remote_ask_checkbox);
	DDX_Control(pDX, IDC_SERVICELIST, m_servicelist);
	DDX_CBString(pDX, IDC_SERVICELIST, m_service);
	DDX_Check(pDX, IDC_REMOTE_ASK, m_remote_ask);
	DDX_Check(pDX, IDC_REMOTE_DIALIN, m_remote_dialin);
	DDX_Check(pDX, IDC_REMOTE_MONITOR, m_remote_monitor);
	DDX_Text(pDX, IDC_REMOTE_TIME, m_remote_time);
	//}}AFX_DATA_MAP

	FillServiceList();
}


void CPPOpt6::FillServiceList()
{
 RASENTRYNAME remRasEntryName[20];
 DWORD dwSize = 20*sizeof(RASENTRYNAME);
 DWORD dwNbEntries;
 remRasEntryName[0].dwSize = sizeof(RASENTRYNAME);

 m_servicelist.ResetContent();
 if ((*lpfnRasEnumEntries)(NULL,NULL,remRasEntryName,&dwSize,&dwNbEntries)==0)
  {
   for (DWORD dwEntry = 0;dwEntry<dwNbEntries;dwEntry++)
      m_servicelist.AddString(remRasEntryName[dwEntry].szEntryName);
  };

 int iSel = m_servicelist.FindStringExact(0,m_service);
 if (iSel!=CB_ERR)
  m_servicelist.SetCurSel(iSel);
}



BEGIN_MESSAGE_MAP(CPPOpt6, CPropertyPage)
	//{{AFX_MSG_MAP(CPPOpt6)
	ON_BN_CLICKED(IDC_EDITENTRY, OnEditentry)
	ON_BN_CLICKED(IDC_LOGONAS, OnLogonas)
	ON_BN_CLICKED(IDC_NEWENTRY, OnNewentry)
	ON_BN_CLICKED(IDC_REMOTE_ASK, OnOptionChanged)
	ON_BN_CLICKED(IDC_REMOTE_MONITOR, OnRemoteMonitor)
	ON_WM_CREATE()
	ON_EN_UPDATE(IDC_REMOTE_TIME, OnOptionChanged)
	ON_CBN_SELCHANGE(IDC_SERVICELIST, OnOptionChanged)
	ON_BN_CLICKED(IDC_REMOTE_DIALIN, OnRemoteMonitor)
	//}}AFX_MSG_MAP
#ifdef WIN32
	ON_MESSAGE(WM_HELP,OnHelp)
    ON_MESSAGE(WM_CONTEXTMENU,OnContextMenu)
#endif
END_MESSAGE_MAP()



void CPPOpt6::UpdatePOPClientFromPage()
{
 AfxGetConfig()->m_bRAAskDisconnect = m_remote_ask;
 AfxGetConfig()->m_bRAMonitor = m_remote_monitor;
 AfxGetConfig()->m_uRATime = m_remote_time;
 AfxGetConfig()->m_bRADialIn = m_remote_dialin;
 AfxGetConfig()->m_csRAService = m_service;
}


/////////////////////////////////////////////////////////////////////////////
// CPPOpt6 message handlers

void CPPOpt6::OnEditentry() 
{
 int iSel = m_servicelist.GetCurSel();
 CString service;

 if (iSel!=CB_ERR)
  {
   m_servicelist.GetLBText(iSel,service);
   (*lpfnRasEditPhonebookEntry)(GetSafeHwnd(),NULL,service.GetBuffer(0));
  } 
}


void CPPOpt6::OnLogonas() 
{
 CLogon clLogonDlg(NULL,AfxGetConfig()->m_csRALogin,AfxGetConfig()->m_csRAPassword);

	if (clLogonDlg.DoModal()==IDOK)
	{
	 AfxGetConfig()->m_csRALogin = clLogonDlg.m_username;
	 AfxGetConfig()->m_csRAPassword = clLogonDlg.m_password;
	}
	
}

void CPPOpt6::OnNewentry() 
{
 (*lpfnRasCreatePhonebookEntry)(GetSafeHwnd(),NULL);	
 FillServiceList();
}

void CPPOpt6::OnOptionChanged() 
{
 SetModified(TRUE);
}


#ifdef WIN32
LONG CPPOpt6::OnHelp(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)((HELPINFO*)lParam)->hItemHandle,AfxGetApp()->m_pszHelpFilePath,HELP_WM_HELP,(DWORD)&Mapping);
}


LONG CPPOpt6::OnContextMenu(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)wParam,AfxGetApp()->m_pszHelpFilePath,HELP_CONTEXTMENU,(DWORD)&Mapping);
}
#endif            
            


void CPPOpt6::OnRemoteMonitor() 
{
 SetModified(TRUE);
 UpdateControls();
}

int CPPOpt6::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
 if (CPropertyPage::OnCreate(lpCreateStruct) == -1)
		return -1;
	
 	return 0;
}

BOOL CPPOpt6::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPPOpt6::UpdateControls()
{
 BOOL monitor = (m_remote_monitor_checkbox.GetCheck()==1);
 BOOL dialin = (m_remote_dialin_checkbox.GetCheck()==1);

 m_remote_dialin_checkbox.EnableWindow(monitor);
 m_remote_ask_checkbox.EnableWindow(monitor && dialin);
 m_remote_time_edit.EnableWindow(monitor && dialin);
 m_servicelist.EnableWindow(monitor && dialin);
}

BOOL CPPOpt6::OnSetActive() 
{
 UpdateControls();	
 return CPropertyPage::OnSetActive();
}
