/*********************************************************************************
 *																				
 *   e-Mail Notify - Internet e-Mail Notifier
 *   Copyright (C) 1996-1998 Ludovic Dubost <ldubost@pobox.com>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 **********************************************************************************/


#include "stdafx.h"
#include "email.h"
#include "mainfrm.h"
#include "popclien.h"
#include "psoption.h"
#include "idhindex.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPSOptions


extern BOOL bRasOk;


static void AFXAPI EnableDlgItem(HWND hWnd, UINT nID, BOOL bEnable,
	int nIDFocus = -1)
{
	HWND hWndItem = ::GetDlgItem(hWnd, nID);
	if (::GetFocus() == hWndItem && nIDFocus != -1)
	{
		HWND hWndTemp = ::GetDlgItem(hWnd, nIDFocus);
		if (hWndTemp != NULL)
			::SetFocus(hWndTemp);
	}
	if (hWndItem != NULL)
		::EnableWindow(hWndItem, bEnable);
}



IMPLEMENT_DYNAMIC(CPSOptions, CPropertySheet)



static DWORD Mapping[] = 
 {
  IDOK, IDH_OK,
  IDCANCEL, IDH_CANCEL,
  ID_APPLY_NOW, IDH_APPLY,
  ID_HELP, IDH_HELP
 };



CPSOptions::CPSOptions(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
 AddPage(&ppopt2);
 AddPage(&ppopt1);
 AddPage(&ppopt3);
 AddPage(&ppopt4);
 AddPage(&ppopt5);
#if defined(WIN95) || defined(WINNT35)
 if (bRasOk) AddPage(&ppopt6);
#endif
}

CPSOptions::CPSOptions(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
 AddPage(&ppopt2);
 AddPage(&ppopt1);
 AddPage(&ppopt3);
 AddPage(&ppopt4);
 AddPage(&ppopt5);
 
#if defined(WIN95) || defined(WINNT35)
 if (bRasOk) AddPage(&ppopt6);
#endif
}

CPSOptions::~CPSOptions()
{
}


void CPSOptions::OnApply()
{
 GetActivePage()->UpdateData(TRUE);
 ppopt1.UpdatePOPClientFromPage();
 ppopt2.UpdatePOPClientFromPage();
 ppopt3.UpdatePOPClientFromPage();
 ppopt4.UpdatePOPClientFromPage();
 ppopt5.UpdatePOPClientFromPage();
#if defined(WIN95) || defined(WINNT35)
 if (bRasOk) ppopt6.UpdatePOPClientFromPage();
#endif
 ppopt1.SetModified(FALSE);
 ppopt2.SetModified(FALSE);
 ppopt3.SetModified(FALSE);
 ppopt4.SetModified(FALSE);
 ppopt5.SetModified(FALSE);

#if defined(WIN95) || defined(WINNT35)
 if (bRasOk) ppopt6.SetModified(FALSE);
#endif

 AfxGetConfig()->SaveProfileString();
}


void CPSOptions::OnOk()
{
 OnApply();
 CPropertySheet::EndDialog(IDOK);
}


BEGIN_MESSAGE_MAP(CPSOptions, CPropertySheet)
	//{{AFX_MSG_MAP(CPSOptions)
	ON_COMMAND(ID_HELP, OnHelpButton)
	ON_WM_CREATE()
	ON_COMMAND(ID_APPLY_NOW, OnApply)
	ON_COMMAND(IDOK, OnOk)
	//}}AFX_MSG_MAP
#ifdef WIN32
	ON_MESSAGE(WM_HELP,OnHelp)
    ON_MESSAGE(WM_CONTEXTMENU,OnContextMenu)
#endif
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPSOptions message handlers

void CPSOptions::OnHelpButton() 
{
 CPropertyPage* active = GetActivePage(); 
 if (active==&ppopt1)
  {
    AfxGetApp()->WinHelp(IDH_CHECKING); 
   return;
  }
 if (active==&ppopt2)
  {
    AfxGetApp()->WinHelp(IDH_SERVER); 
  
   return;
  }
 if (active==&ppopt3)
  {
    AfxGetApp()->WinHelp(IDH_NOTIFY); 
  
   return;
  }
 if (active==&ppopt4)
  {
    AfxGetApp()->WinHelp(IDH_MISC); 
  
   return;
  }
 if (active==&ppopt5)
  {
    AfxGetApp()->WinHelp(IDH_READER); 
  
   return;
  }

#if defined(WIN95) || defined(WINNT35)
 if (active==&ppopt6)
  {
    AfxGetApp()->WinHelp(IDH_RA); 
  
   return;
  }
#endif

 return;  	
}




int CPSOptions::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CPropertySheet::OnCreate(lpCreateStruct) == -1)
		return -1;
	
#ifdef WIN95
	SetForegroundWindow();
#endif

    ::EnableDlgItem(m_hWnd, ID_HELP, TRUE);
		
	return 0;
}


#ifdef WIN32
LONG CPSOptions::OnHelp(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)((HELPINFO*)lParam)->hItemHandle,AfxGetApp()->m_pszHelpFilePath,HELP_WM_HELP,(DWORD)&Mapping);
}


LONG CPSOptions::OnContextMenu(UINT wParam,LONG lParam) 
{
 return ::WinHelp((HWND)wParam,AfxGetApp()->m_pszHelpFilePath,HELP_CONTEXTMENU,(DWORD)&Mapping);
}           
#endif
